SystemOrganization addCategory: #LazyRabbit!

!Browser methodsFor: '*LazyRabbit' stamp: 'hjo 8/22/2009 17:02'!
createLazyRabbitVar

	| rabbit |	
	rabbit := LazyRabbit new.
	rabbit subjectClass: self selectedClass.
	rabbit variableName: ( FillInTheBlank
 	    request: 'new inst var name'
 	    initialAnswer:  ''
    		centerAt: Sensor cursorPoint ).
	rabbit addInstVar.
	rabbit tryToCreateMethods.! !

!Browser methodsFor: '*LazyRabbit-class function' stamp: 'hjo 4/9/2009 13:38'!
shiftedClassListMenu: aMenu
	"Set up the menu to apply to the receiver's class list when the shift key is down"

	^ aMenu addList: #(
			-
			('unsent methods'			browseUnusedMethods	'browse all methods defined by this class that have no senders')
			('unreferenced inst vars'	showUnreferencedInstVars	'show a list of all instance variables that are not referenced in methods')
			('unreferenced class vars'	showUnreferencedClassVars	'show a list of all class variables that are not referenced in methods')
			('subclass template'			makeNewSubclass		'put a template into the code pane for defining of a subclass of this class')
			-
			('sample instance'			makeSampleInstance		'give me a sample instance of this class, if possible')
			('inspect instances'			inspectInstances			'open an inspector on all the extant instances of this class')
			('inspect subinstances'		inspectSubInstances		'open an inspector on all the extant instances of this class and of all of its subclasses')
			-
			('add all meths to current chgs'		addAllMethodsToCurrentChangeSet
																'place all the methods defined by this class into the current change set')
			('create inst var accessors'	createInstVarAccessors	'compile instance-variable access methods for any instance variables that do not yet have them')
			('add lazy rabbit'	createLazyRabbitVar	'adds lazy rabbit variable & accessors')
			-
			('more...'					offerUnshiftedClassListMenu	'return to the standard class-list menu'))! !

Object subclass: #LazyRabbit
	instanceVariableNames: 'subjectClass getterAlreayExists userWantsToOverwriteGetter variableName defaultGeneratorSourceCode defaultGeneratorAlreayExists setterAlreayExists userWantsToOverwriteSetter userWantsToOverwriteDefaultGenerator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit'!

!LazyRabbit methodsFor: 'commands' stamp: 'hjo 8/21/2009 14:08'!
addInstVar

	subjectClass addInstVarName: variableName! !

!LazyRabbit methodsFor: 'as yet unclassified' stamp: 'hjo 8/22/2009 17:16'!
createAllMethodsForSubjectClass

	self revisit: 'write test case for this.'.
	subjectClass instVarNames do: [:v| self variableName: v. self tryToCreateMethods ].! !

!LazyRabbit methodsFor: 'compiling' stamp: 'hjo 8/22/2009 16:59'!
createDefaultGeneratorMehtod

	subjectClass compile: ('default', variableName capitalized , '

	"Return a default object for instance variable ',variableName,'."
	', self defaultDefaultGeneratorSourceCode)
		classified: 'defaults' notifying: nil! !

!LazyRabbit methodsFor: 'compiling' stamp: 'hjo 8/21/2009 13:48'!
createGetterMethod

	subjectClass compile: (variableName ,
'

	^',variableName,' setDefault: #default', variableName capitalized ,' for: self withSetter: #',variableName,':')
		classified: 'accessing' notifying: nil! !

!LazyRabbit methodsFor: 'compiling' stamp: 'hjo 8/21/2009 20:49'!
createSetterMethod

	subjectClass compile: 
	(variableName ,': anObject
		
	',variableName,' := anObject')
		classified: 'accessing' notifying: nil! !

!LazyRabbit methodsFor: 'defaults' stamp: 'hjo 8/21/2009 14:12'!
defaultDefaultGeneratorSourceCode

	"Return a default object for instance variable defaultGeneratorSourceCode."
	^'self shouldBeImplemented'! !

!LazyRabbit methodsFor: 'as yet unclassified' stamp: 'hjo 8/22/2009 16:56'!
defaultGeneratorAlreayExists: aBoolean

	defaultGeneratorAlreayExists := aBoolean! !

!LazyRabbit methodsFor: 'as yet unclassified' stamp: 'hjo 8/21/2009 21:01'!
defaultGeneratorSelector

	^('default' , variableName capitalized) asSymbol! !

!LazyRabbit methodsFor: 'accessing' stamp: 'hjo 8/21/2009 14:11'!
defaultGeneratorSourceCode

	^defaultGeneratorSourceCode setDefault: #defaultDefaultGeneratorSourceCode for: self withSetter: #defaultGeneratorSourceCode:! !

!LazyRabbit methodsFor: 'accessing' stamp: 'hjo 8/21/2009 14:11'!
defaultGeneratorSourceCode: anObject
		
	defaultGeneratorSourceCode := anObject! !

!LazyRabbit methodsFor: 'as yet unclassified' stamp: 'hjo 8/21/2009 21:03'!
defaultGetterSelector
	self shouldBeImplemented! !

!LazyRabbit methodsFor: 'accessing' stamp: 'hjo 8/21/2009 13:44'!
getterAlreayExists: aBoolean

	getterAlreayExists := aBoolean! !

!LazyRabbit methodsFor: 'as yet unclassified' stamp: 'hjo 8/21/2009 21:04'!
getterSelector

	^variableName asSymbol! !

!LazyRabbit methodsFor: 'as yet unclassified' stamp: 'hjo 8/22/2009 17:18'!
setDefaultSourceFromUser

	defaultGeneratorSourceCode := FillInTheBlank
			request: 'Default Generator code'
			initialAnswer:  '^0'
			centerAt: Sensor cursorPoint.
	defaultGeneratorSourceCode isEmpty ifTrue: [ defaultGeneratorSourceCode := self defaultSourceCodeForDefaultGenerator ]! !

!LazyRabbit methodsFor: 'accessing' stamp: 'hjo 8/21/2009 20:44'!
setterAlreayExists: aBoolean

	setterAlreayExists := aBoolean! !

!LazyRabbit methodsFor: 'as yet unclassified' stamp: 'hjo 8/21/2009 20:57'!
setterSelector

	^(variableName , ':') asSymbol! !

!LazyRabbit methodsFor: 'accessing' stamp: 'hjo 8/21/2009 13:44'!
subjectClass: aClass 

	subjectClass := aClass ! !

!LazyRabbit methodsFor: 'commands' stamp: 'hjo 8/21/2009 20:39'!
tryToCreateDefaultGeneratorMethod

	self willCompileDefaultGeneratorMethod ifTrue: [self createDefaultGeneratorMehtod]! !

!LazyRabbit methodsFor: 'commands' stamp: 'hjo 8/21/2009 20:39'!
tryToCreateGetterMethod

	self willCompileGetterMethod ifTrue: [self createGetterMethod ]! !

!LazyRabbit methodsFor: 'commands' stamp: 'hjo 8/21/2009 21:06'!
tryToCreateMethods

	setterAlreayExists := subjectClass selectors includes: self setterSelector.
	defaultGeneratorAlreayExists := subjectClass selectors includes: self defaultGeneratorSelector.
	getterAlreayExists := subjectClass selectors includes: self getterSelector.
	self tryToCreateSetterMethod.
	self revisit: 'default generator is not being created. Suspect #willCreateDefaultGenerator'.
	self tryToCreateDefaultGeneratorMethod.
	self tryToCreateGetterMethod! !

!LazyRabbit methodsFor: 'commands' stamp: 'hjo 8/21/2009 20:39'!
tryToCreateSetterMethod

	self willCompileSetterMethod ifTrue: [self createSetterMethod ]! !

!LazyRabbit methodsFor: 'as yet unclassified' stamp: 'hjo 8/22/2009 16:57'!
userWantsToOverwriteDefaultGenerator: aBoolean

	userWantsToOverwriteDefaultGenerator := aBoolean! !

!LazyRabbit methodsFor: 'accessing' stamp: 'hjo 8/21/2009 13:45'!
userWantsToOverwriteGetter: aBoolean

	userWantsToOverwriteGetter := aBoolean	! !

!LazyRabbit methodsFor: 'accessing' stamp: 'hjo 8/21/2009 20:47'!
userWantsToOverwriteSetter: aBoolean

	userWantsToOverwriteSetter := aBoolean! !

!LazyRabbit methodsFor: 'accessing' stamp: 'hjo 8/21/2009 13:50'!
variableName: aByteString 

	variableName := aByteString 
! !

!LazyRabbit methodsFor: 'testing' stamp: 'hjo 8/21/2009 14:32'!
willAddInstVar

	^variableName notNil and: [variableName size > 0]! !

!LazyRabbit methodsFor: 'testing' stamp: 'hjo 8/22/2009 16:58'!
willCompileDefaultGeneratorMethod

	^self willAddInstVar and: [defaultGeneratorAlreayExists not or: [ userWantsToOverwriteDefaultGenerator]]! !

!LazyRabbit methodsFor: 'testing' stamp: 'hjo 8/21/2009 14:34'!
willCompileGetterMethod

	^self willAddInstVar and: [ getterAlreayExists not or: [ userWantsToOverwriteGetter] ]! !

!LazyRabbit methodsFor: 'testing' stamp: 'hjo 8/21/2009 20:52'!
willCompileSetterMethod

	^self willAddInstVar and: [setterAlreayExists not or: [ userWantsToOverwriteSetter]]! !

!Object methodsFor: '*LazyRabbit' stamp: 'hjo 4/18/2009 15:28'!
setDefault: defaultSymbol for: anObject withSetter: setter

	"I am not nil, so do nothing."
	^self! !

!UndefinedObject methodsFor: '*LazyRabbit' stamp: 'hjo 4/18/2009 15:28'!
setDefault: defaultSymbol for: anObject withSetter: setter

	| default |
	default := anObject perform: defaultSymbol.
	anObject perform: setter with: default.
	^default! !

TestResource subclass: #LazyRabbitTestResource
	instanceVariableNames: 'subjectClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit'!

!LazyRabbitTestResource classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/22/2009 16:00'!
current: aTestResource

	self halt.
	current := aTestResource
			! !

!LazyRabbitTestResource methodsFor: 'as yet unclassified' stamp: 'hjo 8/22/2009 16:20'!
setUp

	super setUp.
	subjectClass := 
		Object 
			subclass: #LazyRabbitTestDummy
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: 'LazyRabbitTestResources'.
! !

!LazyRabbitTestResource methodsFor: 'accessing' stamp: 'hjo 8/22/2009 16:06'!
subjectClass

	^subjectClass! !

!LazyRabbitTestResource methodsFor: 'as yet unclassified' stamp: 'hjo 8/22/2009 16:20'!
tearDown

	subjectClass removeFromSystem.
	super tearDown! !

TestCase subclass: #LazyRabbitTest
	instanceVariableNames: 'rabbit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LazyRabbit'!

!LazyRabbitTest classSide methodsFor: 'as yet unclassified' stamp: 'hjo 8/22/2009 15:47'!
resources

	^Array with: LazyRabbitTestResource! !

!LazyRabbitTest methodsFor: 'running' stamp: 'hjo 8/22/2009 16:24'!
setUp

	super setUp.
	rabbit := LazyRabbit new.
	rabbit subjectClass: self subjectClass
	
! !

!LazyRabbitTest methodsFor: 'accessing' stamp: 'hjo 8/22/2009 16:23'!
subjectClass

	^LazyRabbitTestResource current subjectClass! !

!LazyRabbitTest methodsFor: 'running' stamp: 'hjo 8/22/2009 16:08'!
tearDown

	super tearDown.! !

!LazyRabbitTest methodsFor: 'inst var' stamp: 'hjo 8/22/2009 16:22'!
testAddInstVar

	self deny: (self subjectClass instVarNames includes: 'yy').
	rabbit variableName: 'yy'.
	rabbit addInstVar.
	self assert: (self subjectClass instVarNames includes: 'yy').! !

!LazyRabbitTest methodsFor: 'inst var' stamp: 'hjo 8/21/2009 14:32'!
testAddInstWillNotBeCreatedIfVariableNameIsNil

	rabbit variableName: nil.
	self deny: rabbit willAddInstVar! !

!LazyRabbitTest methodsFor: 'default generator' stamp: 'hjo 8/22/2009 16:55'!
testDefaultGeneratorAlreadyExistsAndUserDoesNotWantToOverwriteIt

	rabbit variableName: 'yy'.
	rabbit defaultGeneratorAlreayExists: true.
	rabbit userWantsToOverwriteDefaultGenerator: false.
	self deny: rabbit willCompileDefaultGeneratorMethod! !

!LazyRabbitTest methodsFor: 'default generator' stamp: 'hjo 8/22/2009 16:55'!
testDefaultGeneratorAlreadyExistsAndUserWantsToOverwriteIt

	rabbit variableName: 'yy'.
	rabbit defaultGeneratorAlreayExists: true.
	rabbit userWantsToOverwriteDefaultGenerator: true.
	self assert: rabbit willCompileDefaultGeneratorMethod! !

!LazyRabbitTest methodsFor: 'default generator' stamp: 'hjo 8/22/2009 16:55'!
testDefaultGeneratorDoesNotExist

	rabbit variableName: 'yy'.
	rabbit defaultGeneratorAlreayExists: false.
	self assert: rabbit willCompileDefaultGeneratorMethod! !

!LazyRabbitTest methodsFor: 'selectors' stamp: 'hjo 8/21/2009 21:00'!
testDefaultGeneratorSelector

	rabbit variableName: 'yy'.
	self assert: rabbit defaultGeneratorSelector = #defaultYy! !

!LazyRabbitTest methodsFor: 'getter' stamp: 'hjo 8/21/2009 14:36'!
testGetterAlreadyExistsAndUserDoesNotWantToOverwriteIt

	rabbit variableName: 'yy'.
	rabbit getterAlreayExists: true.
	rabbit userWantsToOverwriteGetter: false.
	self deny: rabbit willCompileGetterMethod! !

!LazyRabbitTest methodsFor: 'getter' stamp: 'hjo 8/21/2009 14:36'!
testGetterAlreadyExistsAndUserWantsToOverwriteIt

	rabbit variableName: 'yy'.
	rabbit getterAlreayExists: true.
	rabbit userWantsToOverwriteGetter: true.
	self assert: rabbit willCompileGetterMethod! !

!LazyRabbitTest methodsFor: 'getter' stamp: 'hjo 8/21/2009 14:36'!
testGetterDoesNotExist

	rabbit variableName: 'yy'.
	rabbit getterAlreayExists: false.
	rabbit userWantsToOverwriteGetter: true.
	self assert: rabbit willCompileGetterMethod! !

!LazyRabbitTest methodsFor: 'selectors' stamp: 'hjo 8/21/2009 21:03'!
testGetterSelector

	rabbit variableName: 'yy'.
	self assert: rabbit getterSelector = #yy! !

!LazyRabbitTest methodsFor: 'getter' stamp: 'hjo 8/21/2009 14:30'!
testGetterWillNotBeCreatedWhenVariableNameIsNil

	rabbit getterAlreayExists: false.
	rabbit variableName: nil.
	self deny: rabbit willCompileGetterMethod! !

!LazyRabbitTest methodsFor: 'setter' stamp: 'hjo 8/21/2009 20:46'!
testSetterAlreadyExistsAndUserDoesNotWantToOverwriteIt

	rabbit variableName: 'yy'.
	rabbit setterAlreayExists: true.
	rabbit userWantsToOverwriteSetter: false.
	self deny: rabbit willCompileSetterMethod! !

!LazyRabbitTest methodsFor: 'setter' stamp: 'hjo 8/21/2009 20:50'!
testSetterAlreadyExistsAndUserWantsToOverwriteIt

	rabbit variableName: 'yy'.
	rabbit setterAlreayExists: true.
	rabbit userWantsToOverwriteSetter: true.
	self assert: rabbit willCompileSetterMethod! !

!LazyRabbitTest methodsFor: 'setter' stamp: 'hjo 8/21/2009 20:51'!
testSetterDoesNotExist

	rabbit variableName: 'yy'.
	rabbit setterAlreayExists: false.
	rabbit userWantsToOverwriteSetter: true.
	self assert: rabbit willCompileSetterMethod! !

!LazyRabbitTest methodsFor: 'selectors' stamp: 'hjo 8/21/2009 20:56'!
testSetterSelector

	rabbit variableName: 'yy'.
	self assert: rabbit setterSelector = #yy:! !

!LazyRabbitTest methodsFor: 'setter' stamp: 'hjo 8/21/2009 20:52'!
testSetterWillNotBeCreatedWhenVariableNameIsNil

	rabbit setterAlreayExists: false.
	rabbit variableName: nil.
	self deny: rabbit willCompileSetterMethod! !

!LazyRabbitTest methodsFor: 'default generator' stamp: 'hjo 8/22/2009 16:53'!
testTryToCreateDefaultGeneratorMethod

	rabbit defaultGeneratorAlreayExists: false.
	rabbit variableName: 'djz'.
	rabbit addInstVar.
	
	self deny: (self subjectClass selectors includes: #defaultDjz).
	rabbit tryToCreateDefaultGeneratorMethod.
	self assert: (self subjectClass selectors includes: #defaultDjz)! !

!LazyRabbitTest methodsFor: 'getter' stamp: 'hjo 8/22/2009 16:22'!
testTryToCreateGetterMethod

	rabbit getterAlreayExists: false.
	rabbit variableName: 'yyz'.
	rabbit addInstVar.
	
	self deny: (self subjectClass selectors includes: #yyz).
	rabbit tryToCreateGetterMethod.
	self assert: (self subjectClass selectors includes: #yyz)! !

!LazyRabbitTest methodsFor: 'setter' stamp: 'hjo 8/22/2009 16:22'!
testTryToCreateSetterMethod

	rabbit setterAlreayExists: false.
	rabbit variableName: 'yys'.
	rabbit addInstVar.
	
	self deny: (self subjectClass selectors includes: #yys:).
	rabbit tryToCreateSetterMethod.
	self assert: (self subjectClass selectors includes: #yys:)! !
